AutoTurnin = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")

local skip_bag_scan=false

-- quest autocomplete handlers and functions
function AutoTurnin:OnEnable()
  self:RegisterEvent("QUEST_PROGRESS")
  self:RegisterEvent("QUEST_COMPLETE")
  self:RegisterEvent("GOSSIP_SHOW")
end

function AutoTurnin:OnDisable()
  self:UnregisterEvent("QUEST_PROGRESS")
  self:UnregisterEvent("QUEST_COMPLETE")
  self:UnregisterEvent("GOSSIP_SHOW")
end

function AutoTurnin:GOSSIP_SHOW()
if (GetGossipAvailableQuests()) then
  skip_bag_scan = false  
  if (UnitName("target") == "Vinchaxa") then self:ZGHandler() return end
  local i, q, qname
  local gaq = {GetGossipAvailableQuests()}
  for i=1, getn(gaq), 2 do
    for _, qname in pairs(AutoTurnin_AutoQuests) do
      if (string.lower(gaq[i]) == string.lower(qname)) then SelectGossipAvailableQuest(i) return end
    end
  end
  local c = 0
  for i=1, getn(gaq), 2 do
    for qname, q in pairs(AutoTurnin_MultiQuests) do
      if (string.lower(gaq[i]) == string.lower(qname) and self:CountItem(q.turnin) >= q.amount) then
	SelectGossipAvailableQuest(i-c)
	skip_bag_scan = true
	return
      end
    end
    c = c + 1
  end
end
end

function AutoTurnin:QUEST_PROGRESS()
  if (skip_bag_scan) then CompleteQuest() end
  local q, qname
  for _, q in pairs(AutoTurnin_AutoQuests) do
    if (string.lower(GetTitleText()) == string.lower(q)) then CompleteQuest() return end
  end
  for qname, q in pairs(AutoTurnin_MultiQuests) do
    if (string.lower(GetTitleText()) == string.lower(qname) and self:CountItem(q.turnin) >= q.amount) then
      CompleteQuest()
      skip_bag_scan = true
      return
    end
  end
end

function AutoTurnin:QUEST_COMPLETE()
  local q, qname
  if (skip_bag_scan) then GetQuestReward(QuestFrameRewardPanel.itemChoice) end
  for _, q in pairs(AutoTurnin_AutoQuests) do
    if (GetTitleText() == q) then GetQuestReward(QuestFrameRewardPanel.itemChoice) return end
  end
  for qname, q in pairs(AutoTurnin_MultiQuests) do
    if (GetTitleText() == qname) then
      GetQuestReward(QuestFrameRewardPanel.itemChoice)
      return
    end
  end
end

function AutoTurnin:CountItem( item )
  local itemtotal = 0
  local i, cs
  for i=0,4 do
    for cs=1, GetContainerNumSlots(i) do
      local _, itemcount = GetContainerItemInfo( i, cs )
      local itemname = GetContainerItemLink( i, cs )
      if( itemcount ) then
        AutoTurninTT:SetBagItem( i, cs )
        local itemtext = getglobal( "AutoTurninTTTextLeft1" )
        if( itemtext and itemtext:GetText() ~= nil ) then itemname = itext:GetText() end
        if( itemname and string.find( itemname, item, 1, true ) ) then
		itemtotal = itemtotal + itemcount end
      end
    end
  end
  return itemtotal
end

function AutoTurnin:IfMultiItem(item1, item2, item3)
  local itemtotal = 0
  local i, cs, item1found, item2found, item3found
  local item1found = false
  local item2found = false if(item1found and item2found and item3found) then return 1 end
  local item3found = false
  for i=0,4 do
    for cs=1, GetContainerNumSlots(i) do
      local itemname = GetContainerItemLink( i, cs )
      AutoTurninTT:SetBagItem( i, cs )
      local itemtext = getglobal( "AutoTurninTTTextLeft1" )
      if( itemtext and itemtext:GetText() ~= nil ) then itemname = itext:GetText() end
      if( itemname and string.find( itemname, item1, 1, true ) ) then item1found = true end 
      if( itemname and string.find( itemname, item2, 1, true ) ) then item2found = true end
      if( itemname and string.find( itemname, item2, 1, true ) ) then item3found = true end
      if(item1found and item2found and item3found) then return true end
    end
    if(item1found and item2found and item3found) then return true end
  end
  return false
end

function AutoTurnin:ZGHandler()
  local i, q, qname
  local c = 0
  local gaq = {GetGossipAvailableQuests()}
  for i=1, getn(gaq), 2 do
    for qname, q in pairs(AutoTurnin_ZGQuests) do
      if (string.lower(gaq[i]) == string.lower(qname)) then
	if (self:IfMultiItem(q.turnin1, q.turnin2, q.turnin3)) then
	  SelectGossipAvailableQuest(i-c)
	  skip_bag_scan = true
	  return 
	end
      end
    end
    c = c + 1
  end
end
